//
//  MainMenuController.m
//  VetApp
//
//  Created by Victoria Chiu on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MainMenuController.h"
#import "PostQuestionController.h"
#import "QandAController.h"
#import "VetAppAppDelegate.h"
#import "SortByController.h"
#import "FilterByController.h"


@implementation MainMenuController

@synthesize myPostQuestionController, myQandAController, mySettingsController;
@synthesize questionList, dateList, currentElementValue, table, appDelegate, mySortByController, myFilterByController;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */

- (void) awakeFromNib
{
	questionList = [[NSMutableArray alloc] init];
	dateList = [[NSMutableArray alloc] init];
	idList = [[NSMutableArray alloc] init];
}


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	tableColor = TRUE;
	self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
	appDelegate = (VetAppAppDelegate*)[[UIApplication sharedApplication] delegate];
	questionList = [[NSMutableArray alloc] init];
	dateList = [[NSMutableArray alloc] init];
	idList = [[NSMutableArray alloc] init];
	PostQuestionController *aPostQuestionController = [[PostQuestionController alloc]
													   initWithNibName:@"PostQuestionController" bundle:[NSBundle mainBundle]];
	[self setMyPostQuestionController:aPostQuestionController];
	[aPostQuestionController release];
	
	QandAController *aQandAController = [[QandAController alloc]
										 initWithNibName:@"QandAController" bundle:[NSBundle mainBundle]];
	[self setMyQandAController:aQandAController];
	[aQandAController release];
	
	SettingsController *aSettingsController = [[SettingsController alloc]
										  initWithNibName:@"SettingsController" bundle:[NSBundle mainBundle]];
	[self setMySettingsController:aSettingsController];
	[aSettingsController release];
	
	SortByController *aSortByController = [[SortByController alloc]
													   initWithNibName:@"SortByController" bundle:[NSBundle mainBundle]];
	[self setMySortByController:aSortByController];
	[aSortByController release];
	
	FilterByController *aFilterByController = [[FilterByController alloc]
										   initWithNibName:@"FilterByController" bundle:[NSBundle mainBundle]];
	[self setMyFilterByController:aFilterByController];
	[aFilterByController release];
	
	
	
	NSURL *url = [[NSURL alloc] initWithString:@"https://letmeintroduce.com/cs160/get_questions.php"];
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url];
    
    // set the current view controller as the parser's delegate.
    [xmlParser setDelegate: self];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    if(success)
        NSLog(@"No Errors");
    else
        NSLog(@"Error Error Error!!!");   
	
    [super viewDidLoad];
	[url release];
    [xmlParser release];
}

- (IBAction)displaySortBy {
	//SortByController *addController = [[SortByController alloc]
	//											   initWithNibName:@"SortByController" bundle:nil];
	//UINavigationController *navigationController = [[UINavigationController alloc]
	//												initWithRootViewController:addController];
	VetAppAppDelegate *appDelegate = (VetAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	appDelegate.savedController = mySortByController;
	[self presentModalViewController:mySortByController animated:YES];
	
	//[navigationController release];
	//[addController release];
}

- (IBAction)displayFilterBy {
	//SortByController *addController = [[SortByController alloc]
	//											   initWithNibName:@"SortByController" bundle:nil];
	//UINavigationController *navigationController = [[UINavigationController alloc]
	//												initWithRootViewController:addController];
	VetAppAppDelegate *appDelegate = (VetAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	appDelegate.savedFilterController = myFilterByController;
	[self presentModalViewController:myFilterByController animated:YES];
	
	//[navigationController release];
	//[addController release];
}

/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (IBAction)onClickButton:(id)sender{
	
	[[self navigationController] pushViewController:myPostQuestionController animated:YES];
}

- (IBAction)openSettings:(id)sender{
	
	[[self navigationController] pushViewController:mySettingsController animated:YES];
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	
    return [questionList count];
}

- (void)tableView:(UITableView *)tableView accessoryButtonTappedForRowWithIndexPath:(NSIndexPath *)indexPath {
	//[self.navigationController pushViewController:myQandAController animated:YES];
	
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	printf("ROW: %d\n", indexPath.row);
	appDelegate.globalID = [idList objectAtIndex:indexPath.row];
	appDelegate.globalTitle = [questionList objectAtIndex:indexPath.row];
	appDelegate.globalDate = [dateList objectAtIndex:indexPath.row];
	[self.navigationController pushViewController:myQandAController animated:YES];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UIColor *tempColor = [[UIColor alloc] initWithRed:225.0 / 255 green:225.0 / 255 blue:225.0 / 255 alpha:1.0];
    static NSString *CellIdentifier = @"Cell";
	static NSInteger const kquestionLabelTag = 2;
	static NSInteger const kdateLabelTag = 3;
	NSString *cellValue = [questionList objectAtIndex:indexPath.row];
	NSString *dateValue = [dateList objectAtIndex:indexPath.row];
	
	UILabel *dateLabel = nil;
	UILabel *questionLabel = nil;
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
		cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
		
		questionLabel = [[[UILabel alloc] initWithFrame:CGRectMake(10, 9, 230, 29)] autorelease];
        questionLabel.tag = kquestionLabelTag;
        questionLabel.font = [UIFont boldSystemFontOfSize:12];
		/*
		 CGSize maximumLabelSize = CGSizeMake(250,9999);
		 
		 CGSize expectedLabelSize = [cellValue sizeWithFont:questionLabel.font 
		 constrainedToSize:maximumLabelSize 
		 lineBreakMode:questionLabel.lineBreakMode]; 
		 
		 //adjust the label the the new height.
		 CGRect newFrame = questionLabel.frame;
		 newFrame.size.height = expectedLabelSize.height;
		 questionLabel.frame = newFrame;
		 questionLabel.lineBreakMode = UILineBreakModeWordWrap;
		 questionLabel.numberOfLines = 0;
		 */
		
        [cell.contentView addSubview:questionLabel];
		
		dateLabel = [[[UILabel alloc] initWithFrame:CGRectMake(240, 9, 50, 25)] autorelease];
        dateLabel.tag = kdateLabelTag;
        dateLabel.font = [UIFont boldSystemFontOfSize:11];
        dateLabel.autoresizingMask = UIViewAutoresizingFlexibleRightMargin;
		dateLabel.textAlignment = UITextAlignmentRight;
        [cell.contentView addSubview:dateLabel];
    }
	else {
		questionLabel = (UILabel *)[cell.contentView viewWithTag:kquestionLabelTag];
		dateLabel = (UILabel *)[cell.contentView viewWithTag:kdateLabelTag];
	}
	//NSString *cellValue = [questionList objectAtIndex:0];
	//NSString *dateValue = [dateList objectAtIndex:0];
	dateLabel.text = dateValue;
	
	questionLabel.text = cellValue;
	//[questionLabel sizeToFit];
	
    return cell;
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    currentElementValue = string;
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    // parser has just finished reading the temperature_string element, so we set the value found
    //   as the label's text
    if([elementName isEqualToString:@"body"]) {
        [questionList addObject:currentElementValue];
    }else if([elementName isEqualToString:@"date"]) {
        [dateList addObject:currentElementValue];
	}else if ([elementName isEqualToString:@"id"]) {
		[idList addObject:currentElementValue];
	}
}

-(void)viewWillAppear:(BOOL)animated {
	[self refresh];
	[table reloadData];
}

- (void)refresh{
	questionList = [[NSMutableArray alloc] init];
	dateList = [[NSMutableArray alloc] init];
	idList = [[NSMutableArray alloc] init];
	
	NSURL *url = [[NSURL alloc] initWithString:@"https://letmeintroduce.com/cs160/get_questions.php"];
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url];
    
    // set the current view controller as the parser's delegate.
    [xmlParser setDelegate: self];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    if(success)
        NSLog(@"No Errors");
    else
        NSLog(@"Error Error Error!!!");   
	
	[url release];
    [xmlParser release];
}




- (void)dealloc {
	[myFilterByController dealloc];
	[mySortByController dealloc];
	[mySettingsController dealloc];
	[appDelegate dealloc];
	[myQandAController dealloc];
	[myPostQuestionController dealloc];
	[table release];
	[dateList release];
	[questionList release];
	[currentElementValue release];
    [super dealloc];
}


@end
