//
//  PostQuestionController.m
//  VetApp
//
//  Created by Victoria Chiu on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MainMenuController.h"
#import "PostQuestionController.h"
#import "VetAppAppDelegate.h"


@implementation PostQuestionController

@synthesize scrollView;
@synthesize description;
@synthesize animal;
@synthesize age;
@synthesize breed;
@synthesize title;
@synthesize descriptionText;
@synthesize sex;
@synthesize myAttachmentController;
@synthesize attach;
@synthesize appDelegate;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */

- (void)posting{
	NSString *gender = [NSString alloc];
	
	if (sex.selectedSegmentIndex == 0){
		gender = @"Male";
	}
	else if (sex.selectedSegmentIndex == 1){
		gender = @"Female";
	}
	
	NSString *urlLink = [[NSString alloc] initWithFormat:@"https://letmeintroduce.com/cs160/post_question.php?animal_type=%@&breed=%@&sex=%@&age=%@&title=%@&description=%@", [self urlencode:animal.text], [self urlencode:breed.text], [self urlencode:gender], [self urlencode:age.text], [self urlencode:title.text], [self urlencode:descriptionText.text]];
	
	NSURL *url = [[NSURL alloc] initWithString:urlLink];
	[url query];
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url];
	
    
    // set the current view controller as the parser's delegate.
    [xmlParser setDelegate: self];
	NSLog(age.text);
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    if(success)
        NSLog(@"No Errors");
    else
        NSLog(@"Error Error Error!!!");   
	
	[url release];
    [xmlParser release];
	
	UINavigationController *navController = self.navigationController;
	
	// retain ourselves so that the controller will still exist once it's popped off
	[[self retain] autorelease];
	
	// Pop this controller and replace with another
	[navController popViewControllerAnimated:NO];
	if(attach.on){
		[navController pushViewController:myAttachmentController animated:YES];
	}
	animal.text = @"";
	breed.text = @"";
	age.text = @"";
	title.text = @"";
	descriptionText.text = @"";
	[attach setOn:NO animated:NO];
	sex.selectedSegmentIndex = 0;
	
	[animal resignFirstResponder];
	[breed resignFirstResponder];
	[age resignFirstResponder];
	[title resignFirstResponder];
	[description resignFirstResponder];
	
	[(MainMenuController *)appDelegate.myMainMenuController refresh];
	
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
	appDelegate = (VetAppAppDelegate*)[[UIApplication sharedApplication] delegate];
	
	AttachmentController *aAttachmentController = [[AttachmentController alloc]
													   initWithNibName:@"AttachmentController" bundle:[NSBundle mainBundle]];
	[self setMyAttachmentController:aAttachmentController];
	[aAttachmentController release];
	
	
	scrollView.contentSize = CGSizeMake(320, 750);
	[super viewDidLoad];
	self.navigationItem.title = @"Ask a Question";
	UIBarButtonItem *post = [[UIBarButtonItem alloc] initWithTitle:@"Submit" style:UIBarButtonItemStyleBordered target:self action:@selector(posting)];
	self.navigationItem.rightBarButtonItem = post;
	[post release];
	[description setBorderStyle:UITextBorderStyleRoundedRect];
	descriptionText.delegate = self;
	
	
}


/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
    if (theTextField == animal) {
        [animal resignFirstResponder];
    }else if (theTextField == breed) {
        [breed resignFirstResponder];
	}else if (theTextField == age) {
        [age resignFirstResponder];
	}else if (theTextField == title) {
        [title resignFirstResponder];
	}else if (theTextField == description) {
        [description resignFirstResponder];
	}
    return YES;
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    currentElementValue = string;
	NSLog(string);
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    // parser has just finished reading the temperature_string element, so we set the value found
    //   as the label's text
    if([elementName isEqualToString:@"new_id"]) {
        currentID = currentElementValue;
		appDelegate.globalID = currentID;
    }
}

- (NSString *) urlencode: (NSString *) url
{
    NSArray *escapeChars = [NSArray arrayWithObjects:@" ", @";" , @"/" , @"?" , @":" ,
							@"@" , @"&" , @"=" , @"+" ,
							@"$" , @"," , @"[" , @"]",
							@"#", @"!", @"'", @"(", 
							@")", @"*", nil];
	
    NSArray *replaceChars = [NSArray arrayWithObjects:@"%20",@"%3B" , @"%2F" , @"%3F" ,
							 @"%3A" , @"%40" , @"%26" ,
							 @"%3D" , @"%2B" , @"%24" ,
							 @"%2C" , @"%5B" , @"%5D", 
							 @"%23", @"%21", @"%27",
							 @"%28", @"%29", @"%2A", nil];
	
    int len = [escapeChars count];
	
    NSMutableString *temp = [url mutableCopy];
	
    int i;
    for(i = 0; i < len; i++)
    {
		
        [temp replaceOccurrencesOfString: [escapeChars objectAtIndex:i]
							  withString:[replaceChars objectAtIndex:i]
								 options:NSLiteralSearch
								   range:NSMakeRange(0, [temp length])];
    }
	
    NSString *out = [NSString stringWithString: temp];
	
    return out;
}



- (void)dealloc {
	[appDelegate dealloc];
	[attach dealloc];
	[myAttachmentController dealloc];
	[sex dealloc];
	[descriptionText dealloc];
	[animal dealloc];
	[age dealloc];
	[breed dealloc];
	[title dealloc];
	[description dealloc];
	[scrollView dealloc];
    [super dealloc];
}


@end
