//
//  PostResponseController.m
//  VetApp
//
//  Created by Class Account on 4/4/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PostResponseController.h"
#import "MainMenuController.h"
#import "VetAppAppDelegate.h"


@implementation PostResponseController

@synthesize response;
@synthesize responseBackground;
@synthesize questionTitle;
@synthesize appDelegate;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	appDelegate = (VetAppAppDelegate*)[[UIApplication sharedApplication] delegate];
	self.navigationItem.title = @"Post a Response";
	self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
	[responseBackground setBorderStyle:UITextBorderStyleRoundedRect];
	questionTitle.text = appDelegate.globalTitle;
	UIBarButtonItem *post = [[UIBarButtonItem alloc] initWithTitle:@"Post" style:UIBarButtonItemStyleBordered target:self action:@selector(posting)];
	self.navigationItem.rightBarButtonItem = post;
	[post release];
    [super viewDidLoad];
}

- (void)posting{
	NSString *urlLink = [[NSString alloc] initWithFormat:@"https://letmeintroduce.com/cs160/post_response.php?id=%@&response=%@", appDelegate.globalID, [self urlencode:response.text]];
	
	NSURL *url = [[NSURL alloc] initWithString:urlLink];
	[url query];
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url];
	
    
    // set the current view controller as the parser's delegate.
    [xmlParser setDelegate: self];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    if(success)
        NSLog(@"No Errors");
    else
        NSLog(@"Error Error Error!!!");   
	
	[url release];
    [xmlParser release];
	
	UINavigationController *navController = self.navigationController;
	
	// retain ourselves so that the controller will still exist once it's popped off
	[[self retain] autorelease];
	
	// Pop this controller and replace with another
	[navController popViewControllerAnimated:YES];
	response.text = @"";
	
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    currentElementValue = string;
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    // parser has just finished reading the temperature_string element, so we set the value found
    //   as the label's text
    if([elementName isEqualToString:@"answer_id"]) {
        
    }
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

- (NSString *) urlencode: (NSString *) url
{
    NSArray *escapeChars = [NSArray arrayWithObjects:@" ", @";" , @"/" , @"?" , @":" ,
							@"@" , @"&" , @"=" , @"+" ,
							@"$" , @"," , @"[" , @"]",
							@"#", @"!", @"'", @"(", 
							@")", @"*", nil];
	
    NSArray *replaceChars = [NSArray arrayWithObjects:@"%20",@"%3B" , @"%2F" , @"%3F" ,
							 @"%3A" , @"%40" , @"%26" ,
							 @"%3D" , @"%2B" , @"%24" ,
							 @"%2C" , @"%5B" , @"%5D", 
							 @"%23", @"%21", @"%27",
							 @"%28", @"%29", @"%2A", nil];
	
    int len = [escapeChars count];
	
    NSMutableString *temp = [url mutableCopy];
	
    int i;
    for(i = 0; i < len; i++)
    {
		
        [temp replaceOccurrencesOfString: [escapeChars objectAtIndex:i]
							  withString:[replaceChars objectAtIndex:i]
								 options:NSLiteralSearch
								   range:NSMakeRange(0, [temp length])];
    }
	
    NSString *out = [NSString stringWithString: temp];
	
    return out;
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[appDelegate dealloc];
	[response dealloc];
	[responseBackground dealloc];
	[questionTitle dealloc];
    [super dealloc];
}


@end
