//
//  SettingsController.m
//  VetApp
//
//  Created by Class Account on 4/6/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SettingsController.h"
#import "QandAController.h"
#import "VetAppAppDelegate.h"
#import "MainMenuController.h"
#import "RatingTableCell.h"
#import "RingtoneTableCell.h"
#import "VibrateTableCell.h"
#import "TextTableCell.h"

@implementation SettingsController


@synthesize table, myProfileController;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	ProfileController *aProfileController = [[ProfileController alloc]
										 initWithNibName:@"ProfileController" bundle:[NSBundle mainBundle]];
	[self setMyProfileController:aProfileController];
	[aProfileController release];
	
	self.navigationItem.title = @"Settings";
	UIBarButtonItem *post = [[UIBarButtonItem alloc] initWithTitle:@"Submit" style:UIBarButtonItemStyleBordered target:self action:@selector(submit)];
	self.navigationItem.rightBarButtonItem = post;
	[post release];
    [super viewDidLoad];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)submit{
	UINavigationController *navController = self.navigationController;
	
	// retain ourselves so that the controller will still exist once it's popped off
	[[self retain] autorelease];
	
	// Pop this controller and replace with another
	[navController popViewControllerAnimated:YES];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	//NSLog(@"A");
    return 2;
	//return [questionList count];
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	//return 1;
	//return [[questionList lastObject] count];
	//NSLog(@"B");
    return (section == 0) ? 2 : 2;
	
}


-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger) section {
	//NSLog(@"C");
	
	if (section == 0)
		return @"Alert Settings:";
	else
		return @"Account:";
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	if(indexPath.section == 1 && indexPath.row == 1){
		exit(0);
	}
	if(indexPath.section == 0 && indexPath.row == 1){
		[tableView deselectRowAtIndexPath:indexPath animated:YES];
	}
	if(indexPath.section == 1 && indexPath.row == 0){
		[tableView deselectRowAtIndexPath:indexPath animated:YES];
		[self.navigationController pushViewController:myProfileController animated:YES];
	}
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
	if(indexPath.section == 0 && indexPath.row == 1){
		static NSString *CellIdentifier = @"ringtoneCell";
		RingtoneTableCell *cell2 = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
		
		if (!cell2) {
			NSArray *nibObjects = [[NSBundle mainBundle] loadNibNamed:@"RingtoneTableCell" owner:nil options:nil];
			for (id currentObject in nibObjects) {
				if ([currentObject isKindOfClass:[RingtoneTableCell class]]) {
					cell2 = (RingtoneTableCell *) currentObject;
					break;
				}
			}
		}
		
		//cell2.contentView.backgroundColor = [UIColor grayColor];
		return cell2;
	}else if(indexPath.section == 0 && indexPath.row == 0){
		static NSString *CellIdentifier = @"vibrateCell";
		VibrateTableCell *cell2 = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
		
		if (!cell2) {
			NSArray *nibObjects = [[NSBundle mainBundle] loadNibNamed:@"VibrateTableCell" owner:nil options:nil];
			for (id currentObject in nibObjects) {
				if ([currentObject isKindOfClass:[VibrateTableCell class]]) {
					cell2 = (VibrateTableCell *) currentObject;
					break;
				}
			}
		}
		
		//cell2.contentView.backgroundColor = [UIColor grayColor];
		return cell2;
	}else if(indexPath.section == 1){
		static NSString *CellIdentifier = @"textCell";
		TextTableCell *cell2 = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
		
		if (!cell2) {
			NSArray *nibObjects = [[NSBundle mainBundle] loadNibNamed:@"TextTableCell" owner:nil options:nil];
			for (id currentObject in nibObjects) {
				if ([currentObject isKindOfClass:[TextTableCell class]]) {
					cell2 = (TextTableCell *) currentObject;
					break;
				}
			}
		}
		if(indexPath.row == 0){
			cell2.textLabel.text = @"View Profile";
		}else{
			cell2.textLabel.text = @"Logout";
		}
		return cell2;
	}
}


- (void)dealloc {
	[myProfileController dealloc];
	[table dealloc];
    [super dealloc];
}


@end
